!> @typedef The_constants  
!! @name The_constants
!! @code
!! type(The_constants) :: global_constant
!! call global_constant%write
!!@endcode
type The_constants                            
    private
    double precision :: Gravity                !> Gravitational acceleration vector (default=(0 0 -9.81)) (m s-2)
    double precision :: light_speed = 2.99e10  !> Reference local sea level
    public 
    double precision :: Mass
contains
procedure :: set_gravity   !> procedure set_gravity
procedure :: set_config    !> procedure set_configuration
procedure :: set_density   !> procedure set_density
procedure :: write => write_constants
end type