/**
* @file      class.C
* @author    MELIANI
* @version   1.0
* @date      01 Mars 2019
* @brief     TP du cours Doxygen
*
* @details   Ce programme permet de mettre en pratique
*            les notions vues pendant le cours
*            Calcul de la documentation de class en C
*
* @todo
* plus generale
*
* @mainpage Cours Doxygen
*
* @section intro Introduction
*     This code it use to learn Doxygen with fortran
* @section optims Optimisations
*    \subsection loops Les boucles
*       blablabla
*    \subsection cstes Les constantes
*       blablabla
*/

class TheClass
{
  public:

    /**
     * An enum.
     * More detailed enum description.
     */

    enum TEnum {
          TVal1, /**< enum value TVal1. */
          TVal2, /**< enum value TVal2. */
          TVal3  /**< enum value TVal3. */
         }
       *enumPtr, /**< enum pointer. Details. */
       enumVar;  /**< enum variable. Details. */

      /**
       * A constructor.
       * A more elaborate description of the constructor.
       */
      TheClass();

      /**
       * A destructor.
       * A more elaborate description of the destructor.
       */
     ~TheClass();

      /**
       * a normal member taking two arguments and returning an integer value.
       * @param a an integer argument.
       * @param s a constant character pointer.
       * @see TheClass()
       * @see ~TheClass()
       * @see testMeToo()
       * @see publicVar()
       * @return The test results
       */
       int AME_MEMBER(int a,const char *s);

      /**
       * A pure virtual member.
       * @see testMe()
       * @param c1 the first argument.
       * @param c2 the second argument.
       */
       virtual void testMeToo(char c1,char c2) = 0;

      /**
       * a public variable.
       * Details.
       */
       int publicVar;

      /**
       * a function variable.
       * Details.
       */
       int (*handler)(int a,int b);
};
