 ! Small test program
 ! base on "Modern Fortran in Practice" by Arjen Markus
program test_objects

    use geometrical_objects

    implicit none

    type list_of_objects
        class(shape), pointer :: object
    end type
    type(list_of_objects), dimension(2) :: list

    type(rectangle), target    :: rect
    type(square), target       :: sq


    integer                    :: i

    call rect%size( 1.0, 2.0 )
    call sq%size( 1.5 )

    list(1)%object => rect
    list(2)%object => sq

    do i = 1,size(list)
        write(*,*) 'Area: ', list(i)%object%get_area()
    enddo

end program test_objects
