 ! Small test program
 ! base on "Modern Fortran in Practice" by Arjen Markus
!> @file      tp_opt_doc.f90
!! @author    MELIANI
!!
!! ### Institution
!! Observatoire de Paris
!!
!! ### adress
!! Meudon
!!
!! @version   1.0
!! @date      12 Mars 2019
!! @brief     TP du cours optimisation
!!
!! @details   Ce programme permet de mettre en pratique
!!            les notions vues pendant le cours
!!            Calcul de la norme
!!            \f[
!!            \Vert (A \times B) \times x \Vert
!!            \f]
!!            avec A et B matrices et x vecteur
!!
!! @todo Ajouter un type vector
!!
!!
!!
!! @section intro Introduction
!!     This code it use to learn Doxygen with fortran
!! @section optims Optimisations
!!    \subsection loops Les boucles
!!       blablabla
!!    \subsection cstes Les constantes
!!       blablabla
!!
!!       lien avec les boucles: voir \ref loops
!! @section install Installation
!!    Voir le fichier <a href="../../INSTALL">INSTALL</a>
program test_objects

    use geometrical_objects

    implicit none

    type list_of_objects
        class(shape), pointer :: object
    end type
    type(list_of_objects), dimension(2) :: list

    type(rectangle), target    :: rect
    type(square), target       :: sq


    integer                    :: i

    call rect%size( 1.0, 2.0 )
    call sq%size( 1.5 )

    list(1)%object => rect
    list(2)%object => sq

    do i = 1,size(list)
        write(*,*) 'Area: ', list(i)%object%get_area()
    enddo

end program test_objects
